<?php
require_once(DIR_SYSTEM . 'library/nuSoap/nusoap.php');
class ControllerPaymentOCFMellat extends Controller {
	private $error = array();
	
	public function index() {
		
		$this->load->language('payment/ocf_mellat');
		$this->document->setTitle($this->language->get('doc_title'));
		
		$this->load->model('setting/setting');
		
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('ocf_mellat', $this->request->post);
			
			$this->session->data['success'] = $this->language->get('text_success');			
			$this->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
		}
		
		$this->data['heading_title'] = $this->language->get('heading_title');
		
		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['text_none'] = $this->language->get('text_none');
		$this->data['text_wait'] = $this->language->get('text_wait');
		
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
		$this->data['button_settle'] = $this->language->get('button_settle');
		$this->data['button_refund'] = $this->language->get('button_refund');
		
		$this->data['tab_general'] = $this->language->get('tab_general');
		$this->data['tab_settle'] = $this->language->get('tab_settle');
		$this->data['tab_refund'] = $this->language->get('tab_refund');
		
		$this->data['fields_configuration_1'] = $this->language->get('fields_configuration_1');
		$this->data['fields_configuration_2'] = $this->language->get('fields_configuration_2');
		$this->data['fields_configuration_3'] = $this->language->get('fields_configuration_3');
		$this->data['fields_configuration_4'] = $this->language->get('fields_configuration_4');
		
		$this->data['entry_terminal_id'] = $this->language->get('entry_terminal_id');
		$this->data['entry_username'] = $this->language->get('entry_username');
		$this->data['entry_password'] = $this->language->get('entry_password');
		$this->data['entry_order_status'] = $this->language->get('entry_order_status');		
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$this->data['entry_sale_amount'] = $this->language->get('entry_sale_amount');
		$this->data['entry_sale_order_id'] = $this->language->get('entry_sale_order_id');
		$this->data['entry_sale_reference_id'] = $this->language->get('entry_sale_reference_id');
		
 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

  		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_payment'),
			'href'      => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);
		
   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('payment/ocf_mellat', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);
		
		$this->data['action'] = $this->url->link('payment/ocf_mellat', 'token=' . $this->session->data['token'], 'SSL');
		
		$this->data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');	
		
		if (isset($this->request->post['ocf_mellat_terminal_id'])) {
			$this->data['ocf_mellat_terminal_id'] = $this->request->post['ocf_mellat_terminal_id'];
		} else {
			$this->data['ocf_mellat_terminal_id'] = $this->config->get('ocf_mellat_terminal_id'); 
		}
		
		if (isset($this->request->post['ocf_mellat_username'])) {
			$this->data['ocf_mellat_username'] = $this->request->post['ocf_mellat_username'];
		} else {
			$this->data['ocf_mellat_username'] = $this->config->get('ocf_mellat_username'); 
		}
		
		if (isset($this->request->post['ocf_mellat_password'])) {
			$this->data['ocf_mellat_password'] = $this->request->post['ocf_mellat_password'];
		} else {
			$this->data['ocf_mellat_password'] = $this->config->get('ocf_mellat_password'); 
		}
		
		if (isset($this->request->post['ocf_mellat_order_status_id'])) {
			$this->data['ocf_mellat_order_status_id'] = $this->request->post['ocf_mellat_order_status_id'];
		} else {
			$this->data['ocf_mellat_order_status_id'] = $this->config->get('ocf_mellat_order_status_id'); 
		}
		
		if (isset($this->request->post['ocf_mellat_status'])) {
			$this->data['ocf_mellat_status'] = $this->request->post['ocf_mellat_status'];
		} else {
			$this->data['ocf_mellat_status'] = $this->config->get('ocf_mellat_status'); 
		}
		
		if (isset($this->request->post['ocf_mellat_sort_order'])) {
			$this->data['ocf_mellat_sort_order'] = $this->request->post['ocf_mellat_sort_order'];
		} else {
			$this->data['ocf_mellat_sort_order'] = $this->config->get('ocf_mellat_sort_order'); 
		}
				
		$this->load->model('localisation/order_status');
		
		$this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		
		$this->data['token'] = $this->session->data['token'];
		
		$this->template = 'payment/ocf_mellat.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);
		
		$this->response->setOutput($this->render());
	}
	
	public function settle() {
		
		$json = array();
		if (!isset($this->request->get['sale_order_id'])) { $json['error'] = $this->language->get('error_sale_order_id'); }
		if (!isset($this->request->get['sale_reference_id'])) { $json['error'] = $this->language->get('error_sale_reference_id'); }
		
		if (!$json) {
			
			/* Connect */
			$this->load->library('mellat');
			$this->WebService = new Mellat($this->config->get('ocf_mellat_terminal_id'), $this->config->get('ocf_mellat_username'), $this->config->get('ocf_mellat_password'));
			
			$this->data['settle'] = $this->WebService->Settle($this->request->get['sale_order_id'], $this->request->get['sale_reference_id']);
			//$this->data['action'] = $this->WebService->data['Config']['Action'];
			
			if ($this->WebService->errors) {
				$json['error'] = implode(', ', $this->WebService->errors);
			} else {
				if ($this->data['settle']) { 
					$json['success'] = $this->language->get('text_settle_success'); 
				} else {
					$json['error'] = $this->language->get('text_settle_error');
				}
			}
		}
		
		$this->response->setOutput(json_encode($json));
	}
	
	protected function validate() {
		if (!$this->user->hasPermission('modify', 'payment/ocf_mellat')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
				
		if (!$this->error) {
			return true;
		} else {
			return false;
		}	
	}
}
?>